% The function "Eigen" calculates sorted natural frequencies 
% and mass normalized modes of linear undamped systems
% if pdid =0 system is positive definite
% if pdid =1 system is NOT positive definite (ignore it!)
function [U,omega]=UndampedEigen(K,M);
[Uraw D]=eig(K,M);
nf2raw=diag(D);N=length(nf2raw);
% Check for positive definiteness 
if sum(nf2raw<0)  > 0 
    pdid=1;
    lambda=zeros(N,1);,U=zeros(N,N);
    display('system is NOT positive definite');
    return
else
    pdid=0;	
    % sorting of eigens in ascending order
    [lambda,infrm]=sort(nf2raw);   
    U1(:,1:N)=Uraw(:,infrm);
    % mormalise modes by mass
    md=U1.'*M*U1;
    for j=1:N
       U(:,j)=U1(:,j)/sqrt(md(j,j)); 
    end

end
omega=sqrt(lambda);
